<template lang="pug">
header.header(
  :class="{ 'header--white': fullwhite, 'is-scroll': scrolled }"
)
  .container.header__container
    .header__left
      nuxt-link.logo.header__logo(
        :to="{ name: 'index', params: { locale } } | url"
      )
        img(
          v-show="!fullwhite && settings && settings.logo"
          :src="settings.logo"
          alt=""
        )
        img(
          v-show="fullwhite && settings && settings.logo_dark"
          :src="settings.logo_dark"
          alt=""
        )

    .header__center(
      v-if="menus && menus.MAIN_MENU && menus.MAIN_MENU.items.length"
    )
      transition(name="fade")
        nav.header-nav(
          v-show="showMobileMenu"
        )
          ul.header-nav-list
            li.header-nav-list__item(
              v-for="item in menus.MAIN_MENU.items"
              :key="item.id"
            )
              a.header-nav-list__link(
                v-if="item.url.indexOf('http') === 0"
                :href="item.url"
                rel="nofollow"
                target="_blank"
              ) {{ item.title }}
              nuxt-link.header-nav-list__link(
                v-else
                :to="item.url"
              ) {{ item.title }}

    .header__right
      //- a.btn.header__auth-btn.btn--secondary(
      //-   href="#"
      //-   v-if="!fullwhite"
      //- ) Войти
      //- a.btn.header__auth-btn.btn--white(
      //-   href="#"
      //-   v-if="fullwhite"
      //- ) Войти

      //
        dropdown.header-lang.select--white(
          // :options="locales"
          // :initial="activeLocale.value"
          @change="changeLocale"
        )

      .header-lang
        a(
          v-for="loc in locales"
          v-if="activeLocale && loc.text !== activeLocale.text"
          :key="loc.text"
          :href="loc.url"
        ) {{ loc.text }}

      button.header-nav-toggle(
        :class="{ 'is-active': showMobileMenu }"
        v-if="menus && menus.MAIN_MENU && menus.MAIN_MENU.items.length"
        type="button"
        @click="toggleMobileMenu"
      )
        span
        span
        span
</template>

<script>
import { disableBodyScroll, enableBodyScroll, clearAllBodyScrollLocks } from 'body-scroll-lock'
import { mapGetters, mapState } from 'vuex'
import ClickOutside from 'vue-click-outside'
import { phoneUrl, url } from '@/filters'
import config from '@/config'
import eventHub from '@/utils/eventHub'

export default {
  name: 'HeaderBlock',

  beforeDestroy () {
    eventHub.$off('global:closeMenu', this.closeMobileMenu)
    window.removeEventListener('scroll', this.watchScrolled)
  },

  computed: {
    locales () {
      return config.locales.map(l => {
        return {
          // verbose: l,
          url: this.replaceURLByLocale(l),
          text: l // ,
          // value: this.replaceURLByLocale(l)
        }
      })
    },

    activeLocale () {
      return this.locales.find(locale => {
        return locale.text === this.locale
      }) || null
    },
    ...mapGetters({
      settings: 'vars/settings',
      menus: 'vars/menus'
    }),
    ...mapState({
      locale: state => state.locale
    })
  },

  data () {
    return {
      scrolled: false,
      showMobileMenu: false
    }
  },

  filters: { phoneUrl, url },

  directives: { ClickOutside },

  methods: {
    changeLocale (value) {
      window.location.href = value
    },

    closeMobileMenu () {
      this.showMobileMenu = false
      this.toggleBodyScroll(this.showMobileMenu)
    },

    replaceURLByLocale (locale) {
      const urlParts = this.$route.fullPath.split('/')
      if (locale === config.locales[0]) {
        urlParts.splice(1, 1)
      } else if (this.locale !== config.locales[0]) {
        urlParts[1] = locale
      } else {
        urlParts.splice(1, 0, locale)
      }

      let res = url(urlParts.join('/'))
      if (res.length > 1 && res[res.length - 1] === '/') {
        res = res.substr(0, res.length - 1)
      }
      return res
    },

    toggleBodyScroll (value) {
      const target = this.$refs.mobileHeader
      const BodyScrollOptions = {
        reserveScrollBarGap: true
      }

      if (value) {
        disableBodyScroll(target, BodyScrollOptions)
      } else {
        if (target) {
          enableBodyScroll(target, BodyScrollOptions)
        } else {
          clearAllBodyScrollLocks()
        }
      }
    },

    toggleMobileMenu () {
      this.showMobileMenu = !this.showMobileMenu

      this.toggleBodyScroll(this.showMobileMenu)
    },

    watchScrolled () {
      this.scrolled = window.scrollY > 20
    }
  },

  mounted () {
    eventHub.$on('global:closeMenu', this.closeMobileMenu)
    window.addEventListener('scroll', this.watchScrolled)
    this.watchScrolled()
  },

  watch: {
    $route () {
      this.toggleBodyScroll(false)
    }
  },

  props: {
    fullwhite: {
      type: Boolean,
      required: false,
      default: false
    }
  }
}
</script>
